package com.ett.rocketmq.Abstract;

import org.apache.rocketmq.client.exception.MQClientException;
import org.apache.rocketmq.client.producer.DefaultMQProducer;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
/**
 * 长连接producer抽象
 * 生产者的抽象类，定义了start()和shutdown()方法。
 * 其中start()方法需要开发者进行重写。开发者需要在start()方法中，为producer进行初始化和启动工作。
 */
public abstract class AbstractMqProducer {
    protected DefaultMQProducer producer;

    @PostConstruct
    public abstract void start() throws MQClientException;

    @PreDestroy
    public void shutdown() {
        System.err.println("AbstractMqProducer @PreDestroy调用");
        producer.shutdown();
    }
}
